xmonad-contrib-0.13: Third party extensions for xmonad

Copyright | (c) Jan Vornberger 2009
License | BSD3-style (see LICENSE)
Maintainer | jan.vornberger@informatik.uni-oldenburg.de
Stability | unstable
Portability | not portable
Safe Haskell | None
Language | Haskell98

XMonad.Layout.BorderResize

Contents

- Usage

Description

This layout modifier will allow to resize windows by dragging their borders with the mouse. However, it only works in layouts or modified layouts that react to the `SetGeometry` message. XMonad.Layout.WindowArranger can be used to create such a setup, but it is probably must useful in a floating layout such as XMonad.Layout.PositionStoreFloat with which it has been mainly tested. See the documentation of PositionStoreFloat for a typical usage example.

Synopsis

- borderResize :: l a -> ModifiedLayout BorderResize l a
- data BorderResize a = BR (Map Window RectWithBorders)
- type RectWithBorders = (Rectangle, [BorderInfo])
- data BorderInfo

# Usage

You can use this module with the following in your `~/.xmonad/xmonad.hs`:

    import XMonad.Layout.BorderResize
    myLayout = borderResize (... layout setup that reacts to SetGeometry ...)
    main = xmonad def { layoutHook = myLayout }

borderResize :: l a -> ModifiedLayout BorderResize l a #

data BorderResize a #

Constructors

BR (Map Window RectWithBorders) |

Instances

LayoutModifier BorderResize Window # |
Methods modifyLayout :: LayoutClass l Window => BorderResize Window -> Workspace WorkspaceId (l Window) Window -> Rectangle -> X ([(Window, Rectangle)], Maybe (l Window)) # modifyLayoutWithUpdate :: LayoutClass l Window => BorderResize Window -> Workspace WorkspaceId (l Window) Window -> Rectangle -> X (([(Window, Rectangle)], Maybe (l Window)), Maybe (BorderResize Window)) # handleMess :: BorderResize Window -> SomeMessage -> X (Maybe (BorderResize Window)) # handleMessOrMaybeModifyIt :: BorderResize Window -> SomeMessage -> X (Maybe (Either (BorderResize Window) SomeMessage)) # pureMess :: BorderResize Window -> SomeMessage -> Maybe (BorderResize Window) # redoLayout :: BorderResize Window -> Rectangle -> Maybe (Stack Window) -> [(Window, Rectangle)] -> X ([(Window, Rectangle)], Maybe (BorderResize Window)) # pureModifier :: BorderResize Window -> Rectangle -> Maybe (Stack Window) -> [(Window, Rectangle)] -> ([(Window, Rectangle)], Maybe (BorderResize Window)) # hook :: BorderResize Window -> X () # unhook :: BorderResize Window -> X () # modifierDescription :: BorderResize Window -> String # modifyDescription :: LayoutClass l Window => BorderResize Window -> l Window -> String #
Read (BorderResize a) # |
Methods readsPrec :: Int -> ReadS (BorderResize a) # readList :: ReadS [BorderResize a] # readPrec :: ReadPrec (BorderResize a) # readListPrec :: ReadPrec [BorderResize a] #
Show (BorderResize a) # |
Methods showsPrec :: Int -> BorderResize a -> ShowS # show :: BorderResize a -> String # showList :: [BorderResize a] -> ShowS #

type RectWithBorders = (Rectangle, [BorderInfo]) #

data BorderInfo #

Instances

Read BorderInfo # |
Methods readsPrec :: Int -> ReadS BorderInfo # readList :: ReadS [BorderInfo] # readPrec :: ReadPrec BorderInfo # readListPrec :: ReadPrec [BorderInfo] #
Show BorderInfo # |
Methods showsPrec :: Int -> BorderInfo -> ShowS # show :: BorderInfo -> String # showList :: [BorderInfo] -> ShowS #